from spread_core.bam.engineries import alarm
from .subginery import Subginery, _SubgineriesFunit


class Alarm(Subginery):
    def on_level_changed(self, eng):
        if isinstance(eng, alarm.FireSensor):
            funit = FireSensorsGuard

        elif isinstance(eng, alarm.IntruderSensor):
            funit = IntruderSensorsGuard

        elif isinstance(eng, alarm.LeakageSensor):
            funit = LeakageSensorsGuard

        else:
            return

        value = None
        for current_eng in self.engineries:
            if isinstance(current_eng, alarm._AlarmSensor) and current_eng.__class__ == eng.__class__:
                _value = current_eng.recipe.guarded
                if _value is not None:
                    if value is None:
                        value = _value
                    elif value != _value:
                        value = None
                        break

        self.publish_state(funit, value)


class _AlarmFunit(_SubgineriesFunit):
    entity_type = Alarm
    target_class = alarm._AlarmSensor
    target_command = alarm.Guard


Alarm.funit_class = _AlarmFunit


class Guard(_AlarmFunit):
    pass


class IntruderSensorsGuard(_AlarmFunit):
    target_class = alarm.IntruderSensor


class FireSensorsGuard(_AlarmFunit):
    target_class = alarm.FireSensor


class LeakageSensorsGuard(_AlarmFunit):
    target_class = alarm.LeakageSensor


class Triggered(_AlarmFunit):
    pass


Alarm.settable_units = [Guard, IntruderSensorsGuard, FireSensorsGuard, LeakageSensorsGuard]
