from django import forms
from django.db import models

from spread_dashboard.project import bam


class CommissioningStrategy(models.Model):
    area = models.ForeignKey(bam.models.Enginery, on_delete=models.DO_NOTHING, unique=True)
    natural_light = models.BooleanField(default=False)
    lum_flux_maintaining = models.BooleanField(default=False)
    daylight_glare_control = models.BooleanField(default=False)
    individual_configuration = models.BooleanField(default=False)
    load_balancing = models.BooleanField(default=False)
    light_tuning = models.BooleanField(default=False)
    scenes_using = models.BooleanField(default=False)
    lighting_on_request = models.BooleanField(default=False)
    presence_control = models.BooleanField(default=False)
    basic_setup = models.BooleanField(default=False)
    schedule = models.BooleanField(default=False)


class StrategyForm(forms.ModelForm):
    class Meta:
        model = CommissioningStrategy
        fields = '__all__'
        exclude = ['area']
