from django.contrib.auth.decorators import login_required
from django.shortcuts import render

import spread_core.bam.engineries.lighting_area as la
import spread_core.mqtt as mqtt
from spread_dashboard.project import bam
from spread_dashboard.utils import app


@login_required
def index(request):
    return render(
        request,
        'local/equipment/lighting/la/buttons/la_button_presets.html',
        context=dict(
            broker=bam.broker_auth(),
            topic=str(mqtt.project.Preset.broadcast(app().project_id, la.ButtonPreset.__name__, '')),
            project=str(mqtt.project.ProjectFile.engineries(app().project_id)),
            set=str(mqtt.spread.topic.Set(
                mqtt.spread.address.EngineryAddress.broadcast(
                    app().project_id, la.LightingArea.__name__, '+', la.Buttons))),
            state=str(mqtt.spread.topic.State(
                mqtt.spread.address.EngineryAddress.broadcast(
                    app().project_id, la.LightingArea.__name__, '+', la.Buttons))),
        )
    )
